    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------
    028     * UnitType.java
    029     * -------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: UnitType.java,v 1.7 2005/10/18 13:24:19 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 11-Feb-2004 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.util;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Used to indicate absolute or relative units.
    050     *
    051     * @author David Gilbert
    052     */
    053    public final class UnitType implements Serializable {
    054
    055        /** For serialization. */
    056        private static final long serialVersionUID = 6531925392288519884L;
    057
    058        /** Absolute. */
    059        public static final UnitType ABSOLUTE = new UnitType("UnitType.ABSOLUTE");
    060
    061        /** Relative. */
    062        public static final UnitType RELATIVE = new UnitType("UnitType.RELATIVE");
    063
    064        /** The name. */
    065        private String name;
    066
    067        /**
    068         * Private constructor.
    069         *
    070         * @param name  the name.
    071         */
    072        private UnitType(final String name) {
    073            this.name = name;
    074        }
    075
    076        /**
    077         * Returns a string representing the object.
    078         *
    079         * @return The string.
    080         */
    081        public String toString() {
    082            return this.name;
    083        }
    084
    085        /**
    086         * Returns <code>true</code> if this object is equal to the specified
    087         * object, and <code>false</code> otherwise.
    088         *
    089         * @param obj  the other object.
    090         *
    091         * @return A boolean.
    092         */
    093        public boolean equals(final Object obj) {
    094            if (obj == this) {
    095                return true;
    096            }
    097            if (!(obj instanceof UnitType)) {
    098                return false;
    099            }
    100            final UnitType that = (UnitType) obj;
    101            if (!this.name.equals(that.name)) {
    102                return false;
    103            }
    104            return true;
    105        }
    106
    107        /**
    108         * Returns a hash code value for the object.
    109         *
    110         * @return The hashcode
    111         */
    112        public int hashCode() {
    113            return this.name.hashCode();
    114        }
    115
    116        /**
    117         * Ensures that serialization returns the unique instances.
    118         *
    119         * @return The object.
    120         *
    121         * @throws ObjectStreamException if there is a problem.
    122         */
    123        private Object readResolve() throws ObjectStreamException {
    124            if (this.equals(UnitType.ABSOLUTE)) {
    125                return UnitType.ABSOLUTE;
    126            }
    127            else if (this.equals(UnitType.RELATIVE)) {
    128                return UnitType.RELATIVE;
    129            }
    130            return null;
    131        }
    132
    133    }